PointOfSalesWebApp/Models/Sale.cs
using PointOfSalesWebApp.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace PointOfSalesWebApp.Models
{
    public class Sale:BaseEntity
    {
        [Required(ErrorMessage = "Please enter an invoice number")]
        [StringLength(100)]   
        public string SalesInvoiceNo { get; set; }
        public Customer Customer { get; set; }
        [Required(ErrorMessage = "Please choose a Customer")]
        public string CustomerId { get; set; }       
        [StringLength(100)]
        public string Remarks { get; set; }
        public double OverallDiscount { get; set; }
        public virtual ICollection<SalesDetail> SalesDetailses { get; set; }
    }
}

PointOfSalesWebApp/Models/SalesView.cs
namespace PointOfSalesWebApp.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;

    
    public class SalesView
    {
        
        public string SalesInvoiceNo { get; set; }

        
        public int Quantity { get; set; }

        
        public double SRate { get; set; }

       
        public double Vat { get; set; }

        
        public double LineDiscount { get; set; }

        public string FirstName { get; set; }

        public string LastName { get; set; }

        [Display(Name="Product")]
        public string Name { get; set; }

        public string CreatedBy { get; set; }


        public DateTimeOffset CreatedAt { get; set; }
    }
}

PointOfSalesWebApp/Controllers/SalesController.cs
using Microsoft.AspNet.Identity;
using Microsoft.Reporting.WebForms;
using PointOfSalesWebApp.DAL.Gateway;
using PointOfSalesWebApp.Models;
using PointOfSalesWebApp.ViewModels;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.SqlClient;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Web;
using System.Web.Helpers;
using System.Web.Mvc;
using System.Web.UI.WebControls;

namespace PointOfSalesWebApp.Controllers
{
    public class SalesController : Controller
    {
        ApplicationDbContext db = new ApplicationDbContext();
        public SqlRepository<SalesDetail> _SalesContext;

        public SalesController(SqlRepository<SalesDetail> SalesRepo)
        {
            this._SalesContext = SalesRepo;
        }
        // GET: Purchase
        public ActionResult Index(int ProductId = 0)
        {
            var customerList = db.Customers.ToList();
            ViewBag.Customers = customerList;

            var productList = db.Products.ToList();
            ViewBag.Products = productList;
            return View();
        }


        
        public ActionResult SalesView()
        {
           List<SalesView> salesView = db.Database.SqlQuery<SalesView>("exec SalesDetailViewSp").ToList();


            return View(salesView);
        }
        public ActionResult ViewReport(string Inv)
        {
            SalesInfoViewContext salesct = new SalesInfoViewContext();
            ReportViewer reportViewer = new ReportViewer();
            reportViewer.ProcessingMode = ProcessingMode.Local;
            reportViewer.SizeToReportContent = true;


            reportViewer.Width = Unit.Percentage(100);
            reportViewer.Height = Unit.Percentage(100);
            //try
            //{
                //SalesInfoView data = new SalesInfoView();
                IEnumerable<SalesInfoListView> dataList = new List<SalesInfoListView>();

                //SaleInvoiceView saleInvoiceView = new SaleInvoiceView();
                //SqlParameter InvParam = new SqlParameter("@Inv", Inv);
                //SqlParameter InvParam1 = new SqlParameter("@Inv", Inv);

                //data = db.Database.SqlQuery<SalesInfoView>("exec SalesInfoViewSp @Inv", InvParam).FirstOrDefault();
                //dataList = db.Database.SqlQuery<SalesInfoListView>("exec SalesInfoListByInvSp @Inv", InvParam1).ToList();
                List<SalesInfoView> data = salesct.SalesInfoViews.Where(x => x.SalesInvoiceNo == Inv).ToList();
                dataList = salesct.SalesInfoListViews.Where(x => x.SalesInvoiceNo == Inv).ToList();
                reportViewer.LocalReport.ReportPath = Request.MapPath(Request.ApplicationPath) + @"Reports\CustomerInvoice.rdlc";
                reportViewer.LocalReport.DataSources.Add(new ReportDataSource("dsSalesInfo", data));
                reportViewer.LocalReport.DataSources.Add(new ReportDataSource("dsSalesListInfo", dataList));
                ViewBag.ReportViewer = reportViewer;
            //}
            //catch (Exception ex)
            //{
            //    throw;
            //}


            return View();
        }
        //SalesInfoInvoice
        public ActionResult SalesInfoInvoice(string Inv)
        {

            SaleInvoiceView saleInvoiceView = new SaleInvoiceView();
            SqlParameter InvParam = new SqlParameter("@Inv", Inv);
            SqlParameter InvParam1 = new SqlParameter("@Inv", Inv);

            saleInvoiceView.salesInfoView = db.Database.SqlQuery<SalesInfoView>("exec SalesInfoViewSp @Inv", InvParam).FirstOrDefault();
            saleInvoiceView.salesInfoListView = db.Database.SqlQuery<SalesInfoListView>("exec SalesInfoListByInvSp @Inv", InvParam1).ToList();


            return View(saleInvoiceView);
        }
        [HttpGet]
        public JsonResult GetProductInfo(int id)
        {
            string[] pp = new string[3];
            var purchase = db.PurchaseDetails.Where(x => x.BarCode == id).Include(x => x.Product).FirstOrDefault();

            if (purchase != null)
            {
                pp[0] = purchase.ProductId.ToString();
                //pp[1] = purchase.StockQuantity.ToString();
                pp[1] = purchase.Product.Quantity.ToString();
                pp[2] = purchase.SRate.ToString();
            }

            return Json(pp, JsonRequestBehavior.AllowGet);
        }

        [HttpGet]
        public JsonResult AutoCompleteCountry(string term)
        {

            ApplicationDbContext db = new ApplicationDbContext();
            List<String> result = new List<String>();
            result = db.PurchaseDetails.Where(x => x.BarCode.ToString().StartsWith(term)).Select(y => y.BarCode.ToString()).ToList();


            return Json(result, JsonRequestBehavior.AllowGet);
        }




        [HttpPost]
        public JsonResult SaveSales(Sale objSales)
        {

            bool status = false;
            if (true)
            {
                List<Product> productList = new List<Product>();
                List<PurchaseDetail> purchaseDetailsList = new List<PurchaseDetail>();

                using (ApplicationDbContext dc = new ApplicationDbContext())
                {
                    foreach (SalesDetail p in objSales.SalesDetailses)
                    {
                        PurchaseDetail purchaseDetail = dc.PurchaseDetails.Where(x => x.BarCode == p.BarCode).FirstOrDefault();
                        purchaseDetail.StockQuantity = purchaseDetail.StockQuantity - p.Quantity;

                        Product product = dc.Products.Where(x => x.Id == p.ProductId).FirstOrDefault();
                        product.Quantity = product.Quantity - p.Quantity;

                        productList.Add(product);
                        purchaseDetailsList.Add(purchaseDetail);
                    }
                    objSales.ApplicationUserId = User.Identity.GetUserId();
                    objSales.CreatedBy = User.Identity.GetUserName();
                    dc.Sales.Add(objSales);
                    foreach (var p in productList)
                    {
                        dc.Entry(p).State = EntityState.Modified;
                    }

                    foreach (var p in purchaseDetailsList)
                    {
                        dc.Entry(p).State = EntityState.Modified;
                    }

                    dc.SaveChanges();
                    status = true;
                }
            }
            else
            {
                status = false;
            }




            SaleInvoiceView saleInvoiceView = new SaleInvoiceView();
            SqlParameter InvParam = new SqlParameter("@Inv", objSales.SalesInvoiceNo);
            SqlParameter InvParam1 = new SqlParameter("@Inv", objSales.SalesInvoiceNo);

            saleInvoiceView.salesInfoView = db.Database.SqlQuery<SalesInfoView>("exec SalesInfoViewSp @Inv", InvParam).FirstOrDefault();
            saleInvoiceView.salesInfoListView = db.Database.SqlQuery<SalesInfoListView>("exec SalesInfoListByInvSp @Inv", InvParam1).ToList();

            var senderEmail = new MailAddress("mdmohiuddin050505@gmail.com", "Mohiuddin");
            //var receiverEmail = new MailAddress("md.mohiiuddiin@gmail.com", "Receiver");
            var receiverEmail = new MailAddress(saleInvoiceView.salesInfoView.Email, "Receiver");
            var password = "73564681";
            var sub = "Invoice of Purchased Product";
            var body = "Hello"+" "+ saleInvoiceView.salesInfoView.FirstName+" "+ saleInvoiceView.salesInfoView.LastName+",\n"+
                "Invoice Information:"+"\n\n"+"Inv No:"+ saleInvoiceView.salesInfoView.SalesInvoiceNo
                +"\nProduct Information:\n";
            int count = 0;
            double sum = 0;
            foreach (var item in saleInvoiceView.salesInfoListView)
            {
                count++;
                body += @count.ToString()+". "+item.ProductName+", Product Code :"+item.ProductCode+", Quantity:"+item.Quantity+",Price:"+item.SRate+"\n\n";
                sum += (item.Quantity + item.SRate);

            }

            body += "Discount:"+ saleInvoiceView.salesInfoView.OverallDiscount+"%\n\n";
            body += "Total:"+ sum+"\n\n";
            body += "Thank You";


            var smtp = new SmtpClient
            {
                Host = "smtp.gmail.com",
                Port = 587,
                EnableSsl = true,
                DeliveryMethod = SmtpDeliveryMethod.Network,
                UseDefaultCredentials = false,
                Credentials = new NetworkCredential(senderEmail.Address, password)
            };

            smtp.EnableSsl = true;
            using (var mess = new MailMessage(senderEmail, receiverEmail)
            {
                Subject = sub,
                Body = body
            })
            {
                smtp.Send(mess);
            }
            return new JsonResult { Data = new { status = status } };
        }
    }
}

PointOfSalesWebApp/Views/Sales/SalesInfoInvoice.cshtml
@model PointOfSalesWebApp.ViewModels.SaleInvoiceView

@{
    ViewBag.Title = "SalesInfoInvoice";
}
<script>
    function printDiv() {
        var divContents = document.getElementById("forPrint").outerHTML;
        var a = window.open('', '', 'height=800, width=900');
        a.document.write('<html>');
        a.document.write('<head></head>');
        a.document.write('<body>');
        a.document.write(divContents);
        a.document.write('</body></html>');
        a.document.close();
        a.print();
    }
</script>
<input type="button" value="Print" onclick="printDiv()">
<div id="forPrint">
    <div class="col-md-12 row">


        <div class="row" style="width:100%;background-color:white;font-weight:bold;margin:10px">
            <button type="button" class="btn btn-secondary btn-lg btn-block col-md-12" style="width:100%;font-weight:bold;color:azure;padding-top:10px">Customer Invoice</button>

            <br />
            <br />
            <div class="col-md-12 row" style="padding-top:10px">
                <div class="col-md-4">
                    <a class="btn btn-primary" style="" href="/MRSR/SearchRecieve">Back To List</a>


                </div>
            </div>

            <div class="col-md-6" style="padding-top:10px">
                <div class="col-md-12" style="color:orangered">
                    @Html.Label("Invoice No", new { @class = "" })

                </div>
                <div class="col-md-12 text-success">
                    @Html.DisplayFor(x => x.salesInfoView.SalesInvoiceNo)

                </div>
            </div>
            <div class="col-md-6" style="padding-top:10px">
                <div class="col-md-12" style="color:orangered">
                    @Html.Label("Customer Name")
                </div>
                <div class="col-md-12">
                    @Html.DisplayFor(x => x.salesInfoView.FirstName)&nbsp;
                    @Html.DisplayFor(x => x.salesInfoView.LastName)

                </div>
            </div>
            <div class="col-md-6">
                <div class="col-md-12" style="color:orangered">
                    @Html.Label("Date")

                </div>
                <div class="col-md-12">
                    @Html.DisplayFor(x => x.salesInfoView.CreatedAt)
                </div>
            </div>
            <div class="col-md-6">
                <div class="col-md-6" style="color:orangered">
                    @Html.Label("Mobile")

                </div>
                <div class="col-md-12">
                    @Html.DisplayFor(x => x.salesInfoView.MobileNumber)

                </div>
            </div>
            <div class="col-md-6">
                <div class="col-md-12" style="color:orangered">
                    @Html.LabelFor(x => x.salesInfoView.Email)

                </div>
                <div class="col-md-12">
                    @Html.DisplayFor(x => x.salesInfoView.Email)

                </div>
            </div>
            <div class="col-md-6">
                <div class="col-md-12" style="color:orangered">
                    @Html.LabelFor(x => x.salesInfoView.OverallDiscount)
                </div>
                <div class="col-md-12">
                    @Html.DisplayFor(x => x.salesInfoView.OverallDiscount)
                </div>
            </div>
            @{
                var sum = 0.0;
            }
            <div class="col-md-12" style="padding-top:10px">
                <table class="table table-dark table-responsive-xl">
                    <thead>
                        <tr>
                            <th>Product Name</th>
                            <th>Product Code</th>
                            <th>Quantity</th>

                            <th>Discount(%)</th>
                            <th>Vat</th>
                            <th>Price</th>

                        </tr>
                    </thead>
                    <tbody>
                        @foreach (var item in Model.salesInfoListView)
                        {
                            <tr>
                                <td>
                                    @item.ProductName
                                </td>
                                <td>
                                    @item.ProductCode
                                </td>
                                <td>
                                    @item.Quantity
                                </td>
                                <td>
                                    @item.LineDiscount
                                </td>
                                <td>
                                    @item.Vat
                                </td>
                                <td>
                                    @item.SRate
                                </td>
                                @{
                                    if (item.Vat > 0)
                                    {
                                        item.SRate = item.SRate - item.SRate * (item.Vat / 100);
                                    }
                                    if (item.LineDiscount > 0)
                                    {
                                        item.SRate = item.SRate - item.SRate * (item.LineDiscount / 100);
                                    }
                                    sum = Convert.ToDouble(item.Quantity * item.SRate);
                                }
                            </tr>
                        }

                    </tbody>
                    <tfoot>
                        <tr>
                            <td colspan="5" align="right">
                                <p class="text-info">Total: </p>
                            </td>
                            <td colspan="6" align="right">
                                <p class="text-danger">@sum</p>
                            </td>
                        </tr>
                    </tfoot>
                </table>
            </div>


        </div>



    </div>
</div>

PointOfSalesWebApp/Views/Sales/SalesView.cshtml
@model IEnumerable<PointOfSalesWebApp.Models.SalesView>

@{
    ViewBag.Title = "SalesView";
}

<button type="button" class="btn btn-lg btn-secondary" style="margin-top: 3%; margin-bottom: 3%;background-color:darkslategrey;color:azure;font-weight:bold">Sales View</button>

<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table table-striped table-dark">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.SalesInvoiceNo)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Quantity)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.SRate)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Vat)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.LineDiscount)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.FirstName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.LastName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.CreatedBy)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.CreatedAt)
        </th>
        <th></th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.SalesInvoiceNo)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Quantity)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.SRate)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Vat)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.LineDiscount)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.FirstName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.LastName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.CreatedBy)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.CreatedAt)
            </td>
            <td>
                @*@Html.ActionLink("", "Edit", new { @InvNo = item.SalesInvoiceNo }) |*@
                @Html.ActionLink("View", "SalesInfoInvoice", new { @Inv = @item.SalesInvoiceNo }) |
                <a class="btn btn-outline-warning" href="@Url.Action("ViewReport","Sales", new { Inv = item.SalesInvoiceNo })" target="_blank"><i class="far fa-eye"></i></a>

                @Html.ActionLink("Delete", "Delete", new { /* id=item.PrimaryKey */ })
            </td>
        </tr>
    }

</table>

PointOfSalesWebApp/Views/Sales/SendInvoice.cshtml
@{
    ViewBag.Title = "SendInvoice";
}

<h2>SendInvoice</h2>

PointOfSalesWebApp/Views/Sales/ViewReport.cshtml
@using ReportViewerForMvc;
@{
    ViewBag.Title = "View Report";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<style type="text/css">
    iframe {
        width: 100%;
    }
</style>
<div style="margin-top:20px">
    <a class="btn btn-info btn-sm" href="@Url.Action("SalesView","Sales")"><i class="fas fa-angle-left"></i>&nbsp; Back to List</a>
</div>
<div class="container">
    <button type="button" class="btn btn-secondary btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;font-weight:bold;color:azure">View Master Report</button>

    <div class="row" style="margin-top:20px">
        @if (ViewBag.ReportViewer != null)
        {
            @Html.ReportViewer(ViewBag.ReportViewer as Microsoft.Reporting.WebForms.ReportViewer)
        }

    </div>
</div>